#include "ImageBuffer.h"
#include "EasyBMP.h"

ImageBuffer::ImageBuffer()
{
	// do nothing
}

ImageBuffer::ImageBuffer(int width, int height)
{
	w = width;
	h = height;

	raster = new scene::Color*[w];
	for(int i=0; i<w; i++)
	{
		raster[i] = new scene::Color[h];
	}
}

/*ImageBuffer::ImageBuffer(int width, int height, scene::Color background)
{
	
}*/

bool ImageBuffer::set(int x, int y, const scene::Color& color)
{
	if(0 > x || x >= w) 
	{
		return false;
	}
	if(0 > y || y >= h)
	{
		return false;
	}
	raster[x][y] = color;
}

void ImageBuffer::writeBMP(char* filename)
{
	BMP output;
	output.SetSize(w, h);
	output.SetBitDepth(32);
	unsigned int ired, igreen, iblue, ialpha;
	for(int j=0; j<h; j++)
	{
		for(int i=0; i < w; i++)
		{
			//clamp to 0 to 255
			ired = (unsigned int)(256*raster[i][j].r);
			igreen = (unsigned int)(256*raster[i][j].g);
			iblue = (unsigned int)(256*raster[i][j].b);
			ialpha = (unsigned int)(256*raster[i][j].a);
			if(ired > 255)
			{
				ired = 255;
			}
			if(igreen > 255)
			{
				igreen = 255;
			}
			if(iblue > 255)
			{
				iblue = 255;
			}
			if(ialpha > 255)
			{
				ialpha = 255;
			}
			output(i,h-j-1)->Red = ired;
			output(i,h-j-1)->Green = igreen;
			output(i,h-j-1)->Blue = iblue;
			output(i,h-j-1)->Alpha = ialpha;
		}
	}
	output.WriteToFile(filename);
}